jQuery.noConflict()(function($){

	"use strict";

/* ===============================================
   AjaxSelect2
   =============================================== */

	$('.ctypAjaxSelect2').select2({

		ajax: {

			url: ajaxurl,
			dataType: 'json',

			delay: 250,

			data: function (params) {

				return {
					action: 'ctyp_list_posts',
					ctyp_post_type: $(this).attr('data-type'),
					q: params.term,
					page: params.page

				};

			},

		processResults: function (data, params) {

			params.page = params.page || 1;

				return {
					results: data.items,
					more: false,
				};

			},

			cache: true

		},

		placeholder: 'Type here...',
		minimumInputLength: 3,
		width: '98%'
	});


/* ===============================================
   AjaxSelect2
   =============================================== */

	$('.ctypAjaxSelect2Tax').select2({

		ajax: {

			url: ajaxurl,
			dataType: 'json',

			delay: 250,

			data: function (params) {

				return {
					action: 'ctyp_list_taxonomy',
					ctyp_taxonomy_type: $(this).attr('data-type'),
					q: params.term,
					page: params.page

				};

			},

		processResults: function (data, params) {

			params.page = params.page || 1;

				return {
					results: data.items,
					more: false,
				};

			},

			cache: true

		},

		placeholder: 'Type here...',
		minimumInputLength: 3,
		width: '98%'

	});

/* ===============================================
   Message, after save options
   =============================================== */

	$('.ctyp_panel_message').delay(1000).fadeOut(1000);

/* ===============================================
   On off
   =============================================== */

	$('.on-off').on("change",function() {

		if ($(this).val() === "on" ) {
			$('.hidden-element').css({'display':'none'});
		}
		else {
			$('.hidden-element').slideDown("slow");
		}

	});

	$('input[type="checkbox"].on_off').on("change",function() {

		if (!this.checked) {
			$(this).parent('.iPhoneCheckContainer').parent('.ctyp_panel_box').next('.hidden-element').slideUp("slow");
		} else {
			$(this).parent('.iPhoneCheckContainer').parent('.ctyp_panel_box').next('.hidden-element').slideDown("slow");
		}

	});

/* ===============================================
   Option panel
   =============================================== */

	$('.ctyp_panel_container .ctyp_panel_mainbox').css({'display':'none'});
	$('.ctyp_panel_container .inactive').next('.ctyp_panel_mainbox').css({'display':'block'});

	$('.ctyp_panel_container h5.element').each(function(){

		if($(this).next('.ctyp_panel_mainbox').css('display') === 'none') {
			$(this).next('input[name="element-opened"]').remove();
		}

		else {
			$(this).next().append('<input type="hidden" name="element-opened" value="'+$(this).attr('id')+'" />');
		}

	});

	$('.ctyp_panel_container h5.element').on("click", function(){

		if($(this).next('.ctyp_panel_mainbox').css('display') === 'none') {

			$(this).parent('.ctyp_panel_container').addClass('unsortableItem');

			$(this).addClass('inactive');
			$(this).children('img').addClass('inactive');
			$('input[name="element-opened"]').remove();
			$(this).next().append('<input type="hidden" name="element-opened" value="'+$(this).attr('id')+'" />');
		}

		else {

			$(this).parent('.ctyp_panel_container').removeClass('unsortableItem');

			$(this).removeClass('inactive');
			$(this).children('img').removeClass('inactive');
			$(this).next('input[name="element-opened"]').remove();

		}

		$(this).next('.ctyp_panel_mainbox').stop(true,false).slideToggle('slow');

	});

/* ===============================================
   CHOOSE SCRIPT POSITION
   =============================================== */

	function chooseContentPosition (value, content, type) {

		var parent = '#' + content;

		$( parent + ' .' + type + 'cpt').css({'display':'none'});
		$( parent + ' .' + type + 'cpt.' + value).css({'display':'block'});

	}

	$('.selectValue').on('change', function() {

		var type = $(this).attr('data-type');
		var content = $(this).closest('.ctyp_panel_container').attr('id');
		var value = $(this).val();
		chooseContentPosition(value, content, type);

	});

	$('.selectValue').each(function() {

		var type = $(this).attr('data-type');
		var content = $(this).closest('.ctyp_panel_container').attr('id');
		var value = $(this).val();
		chooseContentPosition(value, content, type);

	});

	/* ===============================================
		Content position fix
		=============================================== */

	function contentPositionFix() {

		var switchValue = $(this).parents('.ctyp_panel_slider').attr('class');
		switchValue = switchValue.replace('ctyp_panel_slider ', '');

		if (switchValue === 'off' ) {
			$('.contentPosition').val('woocommerce_thankyou');
			$(".contentPosition option[value='woocommerce_before_thankyou']").attr('disabled', 'disabled');
		} else {
			$(".contentPosition option[value='woocommerce_before_thankyou']").removeAttr('disabled');
		}

	}

	$('.orderDetails').on("click",contentPositionFix);
	$('.orderDetails').each(contentPositionFix);


	/* ===============================================
		RESTORE PLUGIN SETTINGS CONFIRM
		=============================================== */

		$('.ctyp_save_content').on("click", function(){

	    	if (!window.confirm('Do you want to save this content?')) {

				return false;

			}

		});


/* ===============================================
   RESTORE PLUGIN SETTINGS CONFIRM
   =============================================== */

	$('.ctyp_restore_settings').on("click", function(){

    	if (!window.confirm('Do you want to restore the plugin settings？')) {

			return false;

		}

	});

/* ===============================================
   SNIPPET GENERATOR
   =============================================== */


	$('.ctyp_delete_content').on("click", function(){

    	if (window.confirm('Do you want to delete this page？')) {

			var toRemove = $(this).attr('rel');
			$('.ctyp_panel_container.' + toRemove).remove();

		}

	});

});
