<?php

// Exit if accessed directly
if (!defined('ABSPATH')) exit;

if( !class_exists( 'ctyp_ecommerce' ) ) {

	class ctyp_ecommerce {

		/**
		 * Constructor
		 */

		public function __construct() {

			add_action('woocommerce_before_thankyou', array(&$this, 'woocommerceBeforeThankYou'));
			add_action('woocommerce_thankyou', array(&$this, 'woocommerceAfterThankYou'));
			add_filter('wc_get_template', array(&$this, 'getTemplate'), 10, 5 );

		}

		/**
		* WOOCOMMERCE TEMPLATE OVERRIDE
		*/

		public function getTemplate( $located, $template_name ) {

			if ( is_checkout() ) {

				if( isset($_GET['order-received']) ) {

					$orderId = $_GET['order-received'];

				} else {

					$url = $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'];
					if (strpos($url, '/order-received/') !== false) {
						$start = strpos($url, '/order-received/');
						$first_part = substr($url, $start+strlen('/order-received/'));
						$orderId = substr($first_part, 0, strpos($first_part, '/'));
					}

				}

				ob_start();
				$this->woocommerceContent($orderId, 'showOrderDetails');
				$woocommerceContent = ob_get_contents();
				ob_end_clean();

				if (
					strpos($woocommerceContent, 'off') !== false &&
					strpos($woocommerceContent, 'on') === false
				) {

					if (
						'order/order-details.php' == $template_name
						|| 	'order/order-details-item.php' == $template_name
						|| 	'order/order-details-customer.php' == $template_name
					) {

						$located = CTYP_PLUGIN_PATH . 'templates/orderdetails.php';

					}

				}

				if (
					'checkout/thankyou.php' == $template_name &&
					 strpos($woocommerceContent, 'off') !== false &&
					 strpos($woocommerceContent, 'on') === false
				) {

					$located = CTYP_PLUGIN_PATH . 'templates/thankyou.php';

				}

			}

			return $located;

		}

		/**
		* CHECK CONTENT
		*/

		private function isLoadableContent( $ID, $type, $settings, $function, $control ) {

			$loadContent = FALSE;

			if ( call_user_func($function, $type) ) :

				if ( is_array($settings) && in_array('-1', $settings) && $control == 'in_array') {

					$loadContent = TRUE;

				} elseif ( is_array($settings) ) {

					switch ( $control ) {

						case 'in_array':

							if ( in_array($ID, $settings) )
								$loadContent = TRUE;

						break;

						case 'not_in_array':

							if ( !in_array($ID, $settings) && !in_array('-1', $settings) )
								$loadContent = TRUE;

						break;

					}

				}

			endif;

			return $loadContent;

		}

		/**
		* WOOCOMMERCE CONTENT
		*/

		public function woocommerceContent($orderId, $action = 'showContent') {

			global $post;

			$ctyp_setting = ctyp_setting('ctyp_generator');

			if ( is_array($ctyp_setting) ) {

				$order=new WC_Order($orderId);
				$items=$order->get_items();

				foreach($items as $k=>$v) {
					$itemList[] = $v['name'];
				}

				foreach ( $ctyp_setting as $content ) {

					$isLoadableContent = 0;

					switch(true) {

						case (isset($content['include_product']) && $content['product_matchValue'] == 'include') :

							foreach($items as $k => $v) {

								$k=intval($v['product_id']);

								if($k>0) {

									$loadContent = $this->isLoadableContent( $v['product_id'], FALSE, $content['include_product'], 'is_page', 'in_array' );

									if ($loadContent == TRUE)
										$isLoadableContent++;

								}

							}

						break;

						case (isset($content['exclude_product']) && $content['product_matchValue'] == 'exclude') :

							foreach($items as $k => $v) {

								$k=intval($v['product_id']);

								if($k>0) {

									$loadContent = $this->isLoadableContent( $v['product_id'], FALSE, $content['exclude_product'], 'is_page', 'not_in_array' );

									if ($loadContent == TRUE)
										$isLoadableContent++;

								}

							}

						break;

					}

					if ( $isLoadableContent >= 1 ) {

						if ( $content['position'] === current_action() && $action == 'showContent') {

							echo wpautop(stripslashes($content['content']));

						}	elseif ( $action == 'showOrderDetails') {

							echo esc_html($content['order_details']);

						}

					}

				}

			}

		}


		/**
		* WOOCOMMERCE BEFORE THANK YOU
		*/

		public function woocommerceBeforeThankYou($orderId) {

			$this->woocommerceContent($orderId);

		}

		/**
		* WOOCOMMERCE AFTER THANK YOU
		*/

		public function woocommerceAfterThankYou($orderId) {

			$this->woocommerceContent($orderId);

		}


	}

}

?>
