<?php
 
if ( ! defined( 'ABSPATH' ) ) {
    exit;
} // Exit if accessed directly

if( !class_exists( 'ctyp_admin_notice' ) ) {

	class ctyp_admin_notice {
	
		/**
		 * Constructor
		 */
		 
		public function __construct( $fields = array() ) {

			if ( !get_user_meta( get_current_user_id(), 'ctyp_notice_userid_' . get_current_user_id() , TRUE ) ) {

				add_action( 'admin_notices', array(&$this, 'admin_notice') );
				add_action( 'admin_head', array( $this, 'dismiss' ) );
			
			}

		}

		/**
		 * Dismiss notice.
		 */
		
		public function dismiss() {
		
			if ( isset( $_GET['ctyp-dismiss'] ) ) {
		
				update_user_meta( get_current_user_id(), 'ctyp_notice_userid_' . get_current_user_id() , intval($_GET['ctyp-dismiss']) );
				remove_action( 'admin_notices', array(&$this, 'admin_notice') );
				
			} 
		
		}

		/**
		 * Admin notice.
		 */
		 
		public function admin_notice() {
			
			global $pagenow;
			$redirect = ( 'admin.php' == $pagenow ) ? '?page=ctyp_panel&ctyp-dismiss=1' : '?ctyp-dismiss=1';
			
		?>
			
            <div class="update-nag notice ctyp-notice">
            
            	<div class="ctyp-noticedescription">
					<strong><?php _e( 'To enable all features, like the dynamic user data or the shortcodes support, please upgrade to the premium version.', 'custom-thank-you-page' ); ?></strong><br/>
					<?php printf( '<a href="%1$s" class="dismiss-notice">'. __( 'Dismiss this notice', 'custom-thank-you-page' ) .'</a>', esc_url($redirect) ); ?>
                </div>
                
                <a target="_blank" href="<?php echo esc_url( CTYP_UPGRADE_LINK . '/?ref=2&campaign=ctyp-notice' ); ?>" class="button"><?php _e( 'Upgrade to Custom Thank You Page Pro', 'custom-thank-you-page' ); ?></a>
                <div class="clear"></div>

            </div>
		
		<?php
		
		}

	}

}

new ctyp_admin_notice();

?>